package com.alterdekim.game.component.game;

import com.alterdekim.game.message.amf.AMFKey;
import com.alterdekim.game.xml.NumericBooleanSerializer;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import com.fasterxml.jackson.dataformat.xml.annotation.JacksonXmlProperty;
import lombok.AllArgsConstructor;
import lombok.Getter;
import lombok.ToString;

@ToString
@Getter
@AllArgsConstructor
public class BodyAvatarItem {
    @AMFKey(name = "BodyPartTypeId")
    @JacksonXmlProperty(localName = "BodyPartTypeId", isAttribute = true)
    private Integer bodyPartTypeId;

    @AMFKey(name = "Id")
    @JacksonXmlProperty(localName = "Id", isAttribute = true)
    private Long id;

    @AMFKey(name = "Color")
    @JacksonXmlProperty(localName = "Color", isAttribute = true)
    private Integer color;

    @AMFKey(name = "IsBodyPart")
    @JacksonXmlProperty(localName = "IsBodyPart", isAttribute = true)
    @JsonSerialize(using = NumericBooleanSerializer.class)
    private Boolean isBodyPart;

    @AMFKey(name = "BodyPartId")
    @JacksonXmlProperty(localName = "BodyPartId", isAttribute = true)
    private Integer bodyPartId;

    @AMFKey(name = "GoodID")
    @JacksonXmlProperty(localName = "GoodID", isAttribute = true)
    private Long goodId;

    @AMFKey(name = "MediaResourceID")
    @JacksonXmlProperty(localName = "MediaResourceID", isAttribute = true)
    private Integer mediaResourceId;

    @AMFKey(name = "LayerID")
    @JacksonXmlProperty(localName = "LayerID", isAttribute = true)
    private Integer layerId;

    @AMFKey(name = "GoodTypeID")
    @JacksonXmlProperty(localName = "GoodTypeID", isAttribute = true)
    private Integer goodTypeId;
}
