package com.alterdekim.game.component.game;

import com.alterdekim.game.entity.Smile;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonRootName;
import com.fasterxml.jackson.dataformat.xml.annotation.JacksonXmlElementWrapper;
import com.fasterxml.jackson.dataformat.xml.annotation.JacksonXmlProperty;
import lombok.AllArgsConstructor;
import lombok.Getter;

import java.util.List;

@Getter
@AllArgsConstructor
@JsonRootName("response")
public class UserInitInfo {
    @JacksonXmlProperty(localName = "account")
    private UserAccount userAccount;

    @JacksonXmlProperty(localName = "user")
    private UserInfo userInfo;

    @JacksonXmlProperty(localName = "user_phone")
    private UserPhone userPhone;

    @JacksonXmlProperty(localName = "user_magic_abilities")
    @JacksonXmlElementWrapper(useWrapping = true, localName = "user_magic_abilities")
    private List<InitMagicAbility> magicAbilities;

    @JacksonXmlProperty(localName = "smiles")
    @JacksonXmlElementWrapper(useWrapping = true, localName = "smiles")
    private List<Smile> smiles;
}
